#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Program = require("commander");
var dump_1 = require("../dump");
var utils_1 = require("../utils");
var exec = utils_1.Utils.exec;
/**
  Dump CLI.
 */
Program
    .command('create [out]')
    .description('Dumps tutorial data as a JSON file')
    .option('--filter [filter]', 'Filter branches')
    .option('--reject [reject]', 'Reject branches')
    .option('--override', 'Override project file if already exists')
    .action(function (out, options) {
    dump_1.Dump.create(out, {
        filter: options.filter && options.filter.split(/\s+/),
        reject: options.reject && options.reject.split(/\s+/),
    });
});
Program
    .command('diff-releases <dumpFile> <srcRelease> <dstRelease>')
    .description('Prints diff between srcRelease and dstRelease')
    .action(function (dumpFile, srcRelease, dstRelease) {
    utils_1.Utils.inspect(dump_1.Dump.diffReleases(dumpFile, srcRelease, dstRelease));
});
Program.parse(process.argv);
//# sourceMappingURL=tortilla-dump.js.map