#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Program = require("commander");
var local_storage_1 = require("../local-storage");
/**
  Strict CLI.
 */
Program
    .command('get')
    .description('Prints whether strict mode is enabled or disabled')
    .action(function () {
    local_storage_1.localStorage.assertTortilla(true);
    var mode = !!local_storage_1.localStorage.getItem('USE_STRICT');
    printStrictMode(mode);
});
Program
    .command('set <mode>')
    .description('Sets strict mode')
    .action(function (mode) {
    local_storage_1.localStorage.assertTortilla(true);
    mode = JSON.parse(mode);
    if (mode) {
        local_storage_1.localStorage.setItem('USE_STRICT', true);
    }
    else {
        local_storage_1.localStorage.removeItem('USE_STRICT');
    }
    printStrictMode(mode);
});
function printStrictMode(mode) {
    if (mode == null) {
        mode = !!local_storage_1.localStorage.getItem('USE_STRICT');
    }
    var strictStatus = mode ? 'enabled' : 'disabled';
    console.log();
    console.log("Strict mode is " + strictStatus);
    console.log();
}
Program.parse(process.argv);
//# sourceMappingURL=tortilla-strict.js.map