#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Program = require("commander");
var local_storage_1 = require("../local-storage");
var submodule_1 = require("../submodule");
/**
 Submodule CLI.
 */
Program
    .command('add <name> <url>')
    .description('Add submodule <name> from <url>')
    .action(function (name, url, hash) {
    local_storage_1.localStorage.assertTortilla(true);
    submodule_1.Submodule.add(name, url);
});
Program
    .command('remove <name>')
    .description('Remove submodule <name>')
    .action(function (name) {
    local_storage_1.localStorage.assertTortilla(true);
    submodule_1.Submodule.remove(name);
});
Program
    .command('update <name>')
    .description('Update/init submodule <name>')
    .action(function (name) {
    local_storage_1.localStorage.assertTortilla(true);
    submodule_1.Submodule.update(name);
});
Program
    .command('fetch <name>')
    .description('Fetch objects from submodule <name> origin remote')
    .action(function (name) {
    local_storage_1.localStorage.assertTortilla(true);
    submodule_1.Submodule.fetch(name);
});
Program
    .command('reset <name>')
    .description('Unclone submodule <name> but keep it initialized')
    .action(function (name) {
    local_storage_1.localStorage.assertTortilla(true);
    submodule_1.Submodule.reset(name);
});
Program
    .command('checkout <name> <ref>')
    .description('Checkout submodule <name> to <ref>')
    .action(function (name, ref) {
    local_storage_1.localStorage.assertTortilla(true);
    submodule_1.Submodule.checkout(name, ref);
});
Program.parse(process.argv);
//# sourceMappingURL=tortilla-submodule.js.map