"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var Handlebars = require("handlebars");
var paths_1 = require("./paths");
var renderer_1 = require("./renderer");
var utils_1 = require("./utils");
var config = {};
if (utils_1.Utils.exists(paths_1.Paths.config)) {
    /* tslint:disable-next-line */
    config = require(paths_1.Paths.config);
}
function registerCustomTransformations() {
    var _this = this;
    if (config.render && config.render.transformations) {
        Object.keys(config.render.transformations).forEach(function (t) {
            renderer_1.Renderer.registerTransformation(t, 'diffStep', config.render.transformations[t].bind(_this, Handlebars));
        });
    }
}
function getBlacklist() {
    if (config.render && config.render.blacklist) {
        return config.render.blacklist;
    }
    return null;
}
exports.Config = __assign({}, config, { registerCustomTransformations: registerCustomTransformations,
    getBlacklist: getBlacklist });
//# sourceMappingURL=config.js.map