"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var git_1 = require("../git");
var local_storage_1 = require("../local-storage");
/**
  Pre-rebase git hook launches right before we rebase a branch. If an error was thrown
  the rebase process will be aborted with the provided error message.
 */
function run() {
    if (!local_storage_1.localStorage.getItem('USE_STRICT')) {
        return;
    }
    if (!process.env.TORTILLA_CHILD_PROCESS) {
        throw Error("Rebase mode is prohibited! Use '$ tortilla step edit' instead");
    }
    var _a = git_1.Git.activeBranchName().match(/^(.+)-step\d+$/) || [], activeBranch = _a[0], mainBranch = _a[1];
    if (activeBranch) {
        throw Error([
            'Rebase mode is prohibited!',
            "Please checkout '" + mainBranch + "' branch beforehand " +
                ("by running '$ git checkout " + mainBranch + "'"),
        ].join('\n'));
    }
}
run();
//# sourceMappingURL=pre-rebase.js.map