/**
  Shares the same API as a native browser's localStorage but uses in-memory cache
  instead of fs.
 */
export declare class LocalCache<T = any> {
    cache: {
        [key: string]: T;
    };
    constructor();
    getItem(key: string): T | null;
    setItem(key: string, value: T): void;
    removeItem(key: any): void;
    key(n: number): string;
    clear(): void;
    readonly length: number;
}
