"use strict";
/**
  Shares the same API as a native browser's localStorage but uses in-memory cache
  instead of fs.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var LocalCache = /** @class */ (function () {
    function LocalCache() {
        this.cache = {};
    }
    LocalCache.prototype.getItem = function (key) {
        if (this.cache.hasOwnProperty(key)) {
            return this.cache[key];
        }
        return null;
    };
    LocalCache.prototype.setItem = function (key, value) {
        this.cache[key] = value;
    };
    LocalCache.prototype.removeItem = function (key) {
        delete this.cache[key];
    };
    LocalCache.prototype.key = function (n) {
        return Object.keys(this.cache)[n];
    };
    LocalCache.prototype.clear = function () {
        Object.keys(this.cache).forEach(function (key) {
            delete this.cache[key];
        });
    };
    Object.defineProperty(LocalCache.prototype, "length", {
        get: function () {
            return Object.keys(this.cache).length;
        },
        enumerable: true,
        configurable: true
    });
    return LocalCache;
}());
exports.LocalCache = LocalCache;
//# sourceMappingURL=local-cache.js.map