export interface TortillaPaths {
    resolve: () => string;
    resolveTree: (path: string) => object;
    resolveProject: (path: string) => TortillaPaths;
    config: string;
    locales: string;
    readme: string;
    renovate: string;
    storage: string;
    rebaseStates: string;
    gitModules: string;
    travis: string;
    manuals: {
        resolve: () => string;
        templates: string;
        views: string;
    };
    cli: {
        resolve: () => string;
        tortilla: string;
        tortillaManual: string;
        tortillaRelease: string;
        tortillaStep: string;
        tortillaStrict: string;
        tortillaSubmodule: string;
    };
    git: {
        resolve: () => string;
        ignore: string;
        hooks: string;
        rebaseApply: string;
        rebaseMerge: string;
        modules: string;
        heads: {
            resolve: () => string;
            cherryPick: string;
            orig: string;
            revert: string;
        };
        messages: {
            resolve: () => string;
            commit: string;
            merge: string;
            squash: string;
        };
        refs: {
            resolve: () => string;
            heads: string;
            remotes: string;
            tags: string;
        };
    };
    tortillaDir: string;
    tortilla: {
        resolve: () => string;
        dump: string;
        editor: string;
        essentials: string;
        git: string;
        initializer: string;
        localCache: string;
        localStorage: string;
        manual: string;
        package: string;
        paths: string;
        rebase: string;
        release: string;
        step: string;
        submodule: string;
        utils: string;
        hooks: string;
        skeleton: string;
        ascii: {
            resolve: () => string;
            views: string;
        };
        renderer: {
            resolve: () => string;
            helpers: string;
            templates: string;
        };
        translator: {
            resolve: () => string;
            translation: string;
            locales: string;
        };
    };
    npm: {
        resolve: () => string;
        ignore: string;
        package: string;
        modules: string;
    };
}
export declare function resolveProject(cwd: string): TortillaPaths;
export declare const Paths: TortillaPaths;
