"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var step_1 = require("../../step");
var translator_1 = require("../../translator");
var utils_1 = require("../../utils");
var index_1 = require("../index");
/**
  Renders a step's commit message including its translation
 */
var t = translator_1.Translator.translate.bind(translator_1.Translator);
index_1.Renderer.registerHelper('stepMessage', function (options) {
    var params = utils_1.Utils.extend({}, this, options.hash);
    var commitMessage = params.commitMessage;
    var stepDescriptor = step_1.Step.descriptor(commitMessage) || {};
    var stepNumber = stepDescriptor.number || 'root';
    stepDescriptor.module = params.module && utils_1.Utils.upperFirst(params.module);
    stepDescriptor.message = t("step:" + stepNumber, {
        defaultValue: stepDescriptor.message || commitMessage,
        keySeparator: ':',
    });
    return index_1.Renderer.renderTemplateFile('step-message', stepDescriptor);
});
//# sourceMappingURL=step-message.js.map