declare function getRecentStepCommit(offset: any, format?: any): any;
declare function getRecentSuperStepCommit(offset: any, format?: any): any;
declare function getRecentSubStepCommit(offset: any, format?: any): any;
declare function getStepDescriptor(message: any): {
    number: string;
    message: string;
    type: string;
};
declare function getSuperStepDescriptor(message: any): {
    number: number;
    message: any;
};
declare function getSubStepDescriptor(message: any): {
    number: any;
    superNumber: number;
    subNumber: number;
    message: any;
};
declare function pushStep(message: any, options: any): void;
declare function popStep(): void;
declare function tagStep(message: any): void;
declare function stepBack(targetStep: string, options?: {
    interactive: boolean;
}): Promise<void>;
declare function getStepBase(step: any): string;
declare function editStep(steps: any, options?: any): void;
declare function sortStep(step: any): void;
declare function rewordStep(step: any, message: any): void;
declare function showStep(step: any, ...args: any[]): void;
declare function assertStep(step: string | number, silent?: boolean): boolean;
declare function commitStep(step: any, message: any, options?: any): void;
declare function getCurrentStep(): string;
declare function getCurrentSuperStep(): number | "root";
declare function getNextStep(offset?: any): string;
declare function getNextSuperStep(offset?: any): string;
declare function initializeStepMap(pending: any): void;
declare function getStepMap(submoduleCwd?: any, checkPending?: any): any;
declare function ensureStepMap(submoduleCwd?: any, checkPending?: any): boolean;
declare function disposeStepMap(): void;
declare function updateStepMap(type: any, payload: any): void;
declare function getAllSteps(): any;
export declare const Step: {
    push: typeof pushStep;
    pop: typeof popStep;
    tag: typeof tagStep;
    back: typeof stepBack;
    edit: typeof editStep;
    sort: typeof sortStep;
    reword: typeof rewordStep;
    show: typeof showStep;
    assert: typeof assertStep;
    commit: typeof commitStep;
    current: typeof getCurrentStep;
    currentSuper: typeof getCurrentSuperStep;
    next: typeof getNextStep;
    nextSuper: typeof getNextSuperStep;
    base: typeof getStepBase;
    recentCommit: typeof getRecentStepCommit;
    recentSuperCommit: typeof getRecentSuperStepCommit;
    recentSubCommit: typeof getRecentSubStepCommit;
    descriptor: typeof getStepDescriptor;
    superDescriptor: typeof getSuperStepDescriptor;
    subDescriptor: typeof getSubStepDescriptor;
    initializeStepMap: typeof initializeStepMap;
    getStepMap: typeof getStepMap;
    ensureStepMap: typeof ensureStepMap;
    disposeStepMap: typeof disposeStepMap;
    updateStepMap: typeof updateStepMap;
    all: typeof getAllSteps;
};
export {};
