"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
function Translation(value) {
    if (typeof value !== 'string') {
        throw TypeError('argument 1 must be a string');
    }
    utils_1.Utils.delegateProperties(this, value, {
        value: function (handler, methodName, args) {
            return handler.apply(value, args);
        },
        get: function (handler, propertyName) {
            return handler.call(value);
        },
        set: function (handler, propertyName, newValue) {
            return handler.call(value, newValue);
        },
    });
    this._value = value;
}
exports.Translation = Translation;
utils_1.Utils.delegateProperties(Translation.prototype, String.prototype, {
    value: function (handler, methodName, args) {
        return handler.apply(this._value, args);
    },
    get: function (handler, propertyName) {
        return handler.call(this._value);
    },
    set: function (handler, propertyName, value) {
        return handler.call(this._value, value);
    },
});
Object.defineProperty(Translation.prototype, 'constructor', {
    writable: true,
    configurable: true,
    value: Translation,
});
[
    'toKebabCase',
    'toStartCase',
    'lowerFirst',
    'upperFirst',
]
    .forEach(function (methodName) {
    var methodHandler = utils_1.Utils[methodName];
    Object.defineProperty(Translation.prototype, methodName, {
        writable: true,
        configurable: true,
        value: function () {
            return methodHandler.call(utils_1.Utils, this._value);
        },
    });
});
//# sourceMappingURL=translation.js.map