/// <reference types="node" />
import * as ChildProcess from 'child_process';
import { EventEmitter } from 'events';
declare function cwd(): string;
declare function isChildProcessOf(file: any, argv: any, offset?: any): any;
declare function exec(file: string, argv?: string[], options?: any): string;
declare function inspect(str: string, argv?: string[]): ChildProcess.SpawnSyncReturns<string>;
declare function exists(path: any, type?: any): boolean;
declare function scopeEnv(fn: any, env: any): any;
declare function filterMatches(arr: any, pattern: any): any;
declare function merge(destination: any, source: any): any;
declare function extend(destination: any, ...sources: any[]): any;
declare function contract(destination: any, keys: any): any;
declare function pluck(obj: any, keys: any): any;
declare function pad(str: any, length: any, char?: any): string;
declare function padRight(str: any, length: any, char?: any): string;
declare function toKebabCase(str: any): any;
declare function toStartCase(str: any): any;
declare function lowerFirst(str: any): any;
declare function upperFirst(str: any): any;
declare function splitWords(str: any): any;
declare function delegateProperties(destination: any, source: any, modifiers: any): any;
declare function isEqual(objA: any, objB: any): any;
declare function escapeBrackets(str: any): any;
declare function shCmd(cmd: any): any;
declare function naturalSort(as: any, bs: any): any;
declare function setTempCwd(callback: any, tempCwd: any): any;
export declare const freeText: (text: any) => any;
export declare function pluckRemoteData(remoteUrl: any): {
    host: any;
    owner: any;
    repo: any;
};
declare function log(...args: any[]): void;
declare function debug(...args: any[]): void;
export declare const Utils: EventEmitter & {
    cwd: typeof cwd;
    exec: typeof exec;
    inspect: typeof inspect;
    git: any;
    npm: any;
    childProcessOf: typeof isChildProcessOf;
    exists: typeof exists;
    scopeEnv: typeof scopeEnv;
    filterMatches: typeof filterMatches;
    merge: typeof merge;
    extend: typeof extend;
    contract: typeof contract;
    pluck: typeof pluck;
    pad: typeof pad;
    padRight: typeof padRight;
    kebabCase: typeof toKebabCase;
    startCase: typeof toStartCase;
    lowerFirst: typeof lowerFirst;
    upperFirst: typeof upperFirst;
    words: typeof splitWords;
    delegateProperties: typeof delegateProperties;
    isEqual: typeof isEqual;
    escapeBrackets: typeof escapeBrackets;
    shCmd: typeof shCmd;
    naturalSort: typeof naturalSort;
    tempCwd: typeof setTempCwd;
    freeText: (text: any) => any;
    pluckRemoteData: typeof pluckRemoteData;
    log: typeof log;
    debug: typeof debug;
};
export {};
